# This program is designed for awk.
# It's purpose is to translate a virtual font *.vpl
# from T1 encoding to CS encoding scheme.
#
# by Michal Kvasnicka, 1998
#
BEGIN {
# T1 (Cork) ecoding scheme
       cork[0]="grave"
       cork[1]="acute"
       cork[2]="circumflex"
       cork[3]="tilde"
       cork[4]="dieresis"
       cork[5]="hungarumlaut"
       cork[6]="ring"
       cork[7]="caron"
       cork[8]="breve"
       cork[9]="macron"
       cork[10]="dotaccent"
       cork[11]="cedilla"
       cork[12]="ogonek"
       cork[13]="quotesinglbase"
       cork[14]="guilsinglleft"
       cork[15]="guilsinglright"
       cork[16]="quotedblleft"
       cork[17]="quotedblright"
       cork[18]="quotedblbase"
       cork[19]="guillemotleft"
       cork[20]="guillemotright"
       cork[21]="endash"
       cork[22]="emdash"
       cork[23]="notdef"
       cork[24]="zeroinferior"
       cork[25]="dotlessi"
       cork[26]="dotlessj"
       cork[27]="ff"
       cork[28]="fi"
       cork[29]="fl"
       cork[30]="ffi"
       cork[31]="ffl"
       cork[32]="notdef"
       cork[33]="exclam"
       cork[34]="quotedbl"
       cork[35]="numbersign"
       cork[36]="dollar"
       cork[37]="percent"
       cork[38]="ampersand"
       cork[39]="quoteright"
       cork[40]="parenleft"
       cork[41]="parenright"
       cork[42]="asterisk"
       cork[43]="plus"
       cork[44]="comma"
       cork[45]="hyphen"
       cork[46]="period"
       cork[47]="slash"
       cork[48]="zero"
       cork[49]="one"
       cork[50]="two"
       cork[51]="three"
       cork[52]="four"
       cork[53]="five"
       cork[54]="six"
       cork[55]="seven"
       cork[56]="eight"
       cork[57]="nine"
       cork[58]="colon"
       cork[59]="semicolon"
       cork[60]="less"
       cork[61]="equal"
       cork[62]="greater"
       cork[63]="question"
       cork[64]="at"
       cork[65]="A"
       cork[66]="B"
       cork[67]="C"
       cork[68]="D"
       cork[69]="E"
       cork[70]="F"
       cork[71]="G"
       cork[72]="H"
       cork[73]="I"
       cork[74]="J"
       cork[75]="K"
       cork[76]="L"
       cork[77]="M"
       cork[78]="N"
       cork[79]="O"
       cork[80]="P"
       cork[81]="Q"
       cork[82]="R"
       cork[83]="S"
       cork[84]="T"
       cork[85]="U"
       cork[86]="V"
       cork[87]="W"
       cork[88]="X"
       cork[89]="Y"
       cork[90]="Z"
       cork[91]="bracketleft"
       cork[92]="backslash"
       cork[93]="bracketright"
       cork[94]="asciicircum"
       cork[95]="underscore"
       cork[96]="quoteleft"
       cork[97]="a"
       cork[98]="b"
       cork[99]="c"
       cork[100]="d"
       cork[101]="e"
       cork[102]="f"
       cork[103]="g"
       cork[104]="h"
       cork[105]="i"
       cork[106]="j"
       cork[107]="k"
       cork[108]="l"
       cork[109]="m"
       cork[110]="n"
       cork[111]="o"
       cork[112]="p"
       cork[113]="q"
       cork[114]="r"
       cork[115]="s"
       cork[116]="t"
       cork[117]="u"
       cork[118]="v"
       cork[119]="w"
       cork[120]="x"
       cork[121]="y"
       cork[122]="z"
       cork[123]="braceleft"
       cork[124]="bar"
       cork[125]="braceright"
       cork[126]="asciitilde"
       cork[127]="hyphen"
       cork[128]="Abreve"
       cork[129]="Aogonek"
       cork[130]="Cacute"
       cork[131]="Ccaron"
       cork[132]="Dcaron"
       cork[133]="Ecaron"
       cork[134]="Eogonek"
       cork[135]="Gbreve"
       cork[136]="Lacute"
       cork[137]="Lcaron"
       cork[138]="Lslash"
       cork[139]="Nacute"
       cork[140]="Ncaron"
       cork[141]="Ng"
       cork[142]="Ohungarumlaut"
       cork[143]="Racute"
       cork[144]="Rcaron"
       cork[145]="Sacute"
       cork[146]="Scaron"
       cork[147]="Scedilla"
       cork[148]="Tcaron"
       cork[149]="Tcedilla"
       cork[150]="Uhungarumlaut"
       cork[151]="Uring"
       cork[152]="Ldot"
       cork[153]="Zacute"
       cork[154]="Zcaron"
       cork[155]="Zdotaccent"
       cork[156]="IJ"
       cork[157]="Idotaccent"
       cork[158]="dbar"
       cork[159]="section"
       cork[160]="abreve"
       cork[161]="aogonek"
       cork[162]="cacute"
       cork[163]="ccaron"
       cork[164]="dcaron"
       cork[165]="ecaron"
       cork[166]="eogonek"
       cork[167]="gbreve"
       cork[168]="lacute"
       cork[169]="lcaron"
       cork[170]="lslash"
       cork[171]="nacute"
       cork[172]="ncaron"
       cork[173]="ng"
       cork[174]="ohungarumlaut"
       cork[175]="racute"
       cork[176]="rcaron"
       cork[177]="sacute"
       cork[178]="scaron"
       cork[179]="scedilla"
       cork[180]="tcaron"
       cork[181]="tcedilla"
       cork[182]="uhungarumlaut"
       cork[183]="uring"
       cork[184]="ldot"
       cork[185]="zacute"
       cork[186]="zcaron"
       cork[187]="zdotaccent"
       cork[188]="ij"
       cork[189]="exclamdown"
       cork[190]="questiondown"
       cork[191]="sterling"
       cork[192]="Agrave"
       cork[193]="Aacute"
       cork[194]="Acircumflex"
       cork[195]="Atilde"
       cork[196]="Adieresis"
       cork[197]="Aring"
       cork[198]="AE"
       cork[199]="Ccedilla"
       cork[200]="Egrave"
       cork[201]="Eacute"
       cork[202]="Ecircumflex"
       cork[203]="Edieresis"
       cork[204]="Igrave"
       cork[205]="Iacute"
       cork[206]="Icircumflex"
       cork[207]="Idieresis"
       cork[208]="Eth"
       cork[209]="Ntilde"
       cork[210]="Ograve"
       cork[211]="Oacute"
       cork[212]="Ocircumflex"
       cork[213]="Otilde"
       cork[214]="Odieresis"
       cork[215]="OE"
       cork[216]="Oslash"
       cork[217]="Ugrave"
       cork[218]="Uacute"
       cork[219]="Ucircumflex"
       cork[220]="Udieresis"
       cork[221]="Yacute"
       cork[222]="Thorn"
       cork[223]="SS"
       cork[224]="agrave"
       cork[225]="aacute"
       cork[226]="acircumflex"
       cork[227]="atilde"
       cork[228]="adieresis"
       cork[229]="aring"
       cork[230]="ae"
       cork[231]="ccedilla"
       cork[232]="egrave"
       cork[233]="eacute"
       cork[234]="ecircumflex"
       cork[235]="edieresis"
       cork[236]="igrave"
       cork[237]="iacute"
       cork[238]="icircumflex"
       cork[239]="idieresis"
       cork[240]="eth"
       cork[241]="ntilde"
       cork[242]="ograve"
       cork[243]="oacute"
       cork[244]="ocircumflex"
       cork[245]="otilde"
       cork[246]="odieresis"
       cork[247]="oe"
       cork[248]="oslash"
       cork[249]="ugrave"
       cork[250]="uacute"
       cork[251]="ucircumflex"
       cork[252]="udieresis"
       cork[253]="yacute"
       cork[254]="thorn"
       cork[255]="germandbls"
#
# CS encoding scheme
       latin["Gamma"]=0
       latin["Delta"]=1
       latin["Theta"]=2
       latin["Lambda"]=3
       latin["Xi"]=4
       latin["Pi"]=5
       latin["Sigma"]=6
       latin["Upsilon"]=7
       latin["Phi"]=8
       latin["Psi"]=9
       latin["Omega"]=10
       latin["ff"]=11
       latin["fi"]=12
       latin["fl"]=13
       latin["ffi"]=14
       latin["ffl"]=15
       latin["dotlessi"]=16
       latin["dotlessj"]=17
       latin["grave"]=18
       latin["acute"]=19
       latin["caron"]=20
       latin["breve"]=21
       latin["macron"]=22
       latin["ring"]=23
       latin["cedilla"]=24
       latin["germandbls"]=25
       latin["ae"]=26
       latin["oe"]=27
       latin["oslash"]=28
       latin["AE"]=29
       latin["OE"]=30
       latin["Oslash"]=31
       latin["notdef"]=32
       latin["exclam"]=33
       latin["quotedblright"]=34
       latin["numbersign"]=35
       latin["dollar"]=36
       latin["percent"]=37
       latin["ampersand"]=38
       latin["quoteright"]=39
       latin["parenleft"]=40
       latin["parenright"]=41
       latin["asterisk"]=42
       latin["plus"]=43
       latin["comma"]=44
       latin["hyphen"]=45
       latin["period"]=46
       latin["slash"]=47
       latin["zero"]=48
       latin["one"]=49
       latin["two"]=50
       latin["three"]=51
       latin["four"]=52
       latin["five"]=53
       latin["six"]=54
       latin["seven"]=55
       latin["eight"]=56
       latin["nine"]=57
       latin["colon"]=58
       latin["semicolon"]=59
       latin["exclamdown"]=60
       latin["equal"]=61
       latin["questiondown"]=62
       latin["question"]=63
       latin["at"]=64
       latin["A"]=65
       latin["B"]=66
       latin["C"]=67
       latin["D"]=68
       latin["E"]=69
       latin["F"]=70
       latin["G"]=71
       latin["H"]=72
       latin["I"]=73
       latin["J"]=74
       latin["K"]=75
       latin["L"]=76
       latin["M"]=77
       latin["N"]=78
       latin["O"]=79
       latin["P"]=80
       latin["Q"]=81
       latin["R"]=82
       latin["S"]=83
       latin["T"]=84
       latin["U"]=85
       latin["V"]=86
       latin["W"]=87
       latin["X"]=88
       latin["Y"]=89
       latin["Z"]=90
       latin["bracketleft"]=91
       latin["quotedblleft"]=92
       latin["bracketright"]=93
       latin["circumflex"]=94
       latin["dotaccent"]=95
       latin["quoteleft"]=96
       latin["a"]=97
       latin["b"]=98
       latin["c"]=99
       latin["d"]=100
       latin["e"]=101
       latin["f"]=102
       latin["g"]=103
       latin["h"]=104
       latin["i"]=105
       latin["j"]=106
       latin["k"]=107
       latin["l"]=108
       latin["m"]=109
       latin["n"]=110
       latin["o"]=111
       latin["p"]=112
       latin["q"]=113
       latin["r"]=114
       latin["s"]=115
       latin["t"]=116
       latin["u"]=117
       latin["v"]=118
       latin["w"]=119
       latin["x"]=120
       latin["y"]=121
       latin["z"]=122
       latin["endash"]=123
       latin["emdash"]=124
       latin["hungarumlaut"]=125
       latin["tilde"]=126
       latin["dieresis"]=127
       latin["ellipsis"]=128
       latin["dagger"]=129
       latin["daggerdbl"]=130
       latin["bullet"]=131
       latin["sterling"]=132
       latin["paragraph"]=133
       latin["notdef"]=134
       latin["notdef"]=135
       latin["notdef"]=136
       latin["notdef"]=137
       latin["notdef"]=138
       latin["notdef"]=139
       latin["notdef"]=140
       latin["perthousand"]=141
       latin["notdef"]=142
       latin["notdef"]=143
       latin["notdef"]=144
       latin["notdef"]=145
       latin["notdef"]=146
       latin["notdef"]=147
       latin["notdef"]=148
       latin["notdef"]=149
       latin["notdef"]=150
       latin["notdef"]=151
       latin["Agrave"]=152
       latin["notdef"]=153
       latin["notdef"]=154
       latin["notdef"]=155
#       latin["hyphen"]=156
       latin["ogonek"]=157
       latin["guillemotleft"]=158
       latin["guillemotright"]=159
       latin["notdef"]=160
       latin["Aogonek"]=161
       latin["breve"]=162
       latin["Lslash"]=163
       latin["currency"]=164
       latin["Lcaron"]=165
       latin["Sacute"]=166
       latin["section"]=167
       latin["dieresis"]=168
       latin["Scaron"]=169
       latin["Scedilla"]=170
       latin["Tcaron"]=171
       latin["Zacute"]=172
       latin["notdef"]=173
       latin["Zcaron"]=174
       latin["Zdotaccent"]=175
       latin["ring"]=176
       latin["aogonek"]=177
       latin["cedilla"]=178
       latin["lslash"]=179
       latin["acute"]=180
       latin["lcaron"]=181
       latin["sacute"]=182
       latin["caron"]=183
       latin["agrave"]=184
       latin["scaron"]=185
       latin["scedilla"]=186
       latin["tcaron"]=187
       latin["zacute"]=188
       latin["hungarumlaut"]=189
       latin["zcaron"]=190
       latin["zdotaccent"]=191
       latin["Racute"]=192
       latin["Aacute"]=193
       latin["Acircumflex"]=194
       latin["Abreve"]=195
       latin["Adieresis"]=196
       latin["Lacute"]=197
       latin["Cacute"]=198
       latin["Ccedilla"]=199
       latin["Ccaron"]=200
       latin["Eacute"]=201
       latin["Eogonek"]=202
       latin["Edieresis"]=203
       latin["Ecaron"]=204
       latin["Iacute"]=205
       latin["Icircumflex"]=206
       latin["Dcaron"]=207
       latin["Eth"]=208
       latin["Nacute"]=209
       latin["Ncaron"]=210
       latin["Oacute"]=211
       latin["Ocircumflex"]=212
       latin["Ohungarumlaut"]=213
       latin["Odieresis"]=214
       latin["multiply"]=215
       latin["Rcaron"]=216
       latin["Uring"]=217
       latin["Uacute"]=218
       latin["Uhungarumlaut"]=219
       latin["Udieresis"]=220
       latin["Yacute"]=221
       latin["Togonek"]=222
       latin["germandbls"]=223
       latin["racute"]=224
       latin["aacute"]=225
       latin["acircumflex"]=226
       latin["abreve"]=227
       latin["adieresis"]=228
       latin["lacute"]=229
       latin["cacute"]=230
       latin["ccedilla"]=231
       latin["ccaron"]=232
       latin["eacute"]=233
       latin["eogonek"]=234
       latin["edieresis"]=235
       latin["ecaron"]=236
       latin["iacute"]=237
       latin["icircumflex"]=238
       latin["dcaron"]=239
       latin["eth"]=240
       latin["nacute"]=241
       latin["ncaron"]=242
       latin["oacute"]=243
       latin["ocircumflex"]=244
       latin["ohungarumlaut"]=245
       latin["odieresis"]=246
       latin["divide"]=247
       latin["rcaron"]=248
       latin["uring"]=249
       latin["uacute"]=250
       latin["uhungarumlaut"]=251
       latin["udieresis"]=252
       latin["yacute"]=253
       latin["quotedblbase"]=254
       latin["quotedblleft"]=255
       latin["notdef"]=-1
       
       ignorelabel=0
       ignorechar=0
}      

# This function translates an octal number to a decadic one
function octtodec(oct){
  delka=length(oct)
  pocitadlo=0
  dec=0
  while(pocitadlo<delka){
    pocitadlo=pocitadlo+1
    dec=substr(oct,pocitadlo,1)+dec*8
    }
  return(dec)
}

#This function translates number in T1 (octal) code to CS (decadic) code
function ctol(co){
  decnum=octtodec(co)
  letter=cork[decnum]
  if(latin[letter]=="")
    lnum=-1
  else
    lnum=latin[letter]
  return(lnum)
}

#This function is to keep spaces before the elements of a row
function corspace(line){
  where=index(line,"(")
  cs=substr(line,1,where-1)
  return(cs)
}
  
#Main (function of the) program
{
if(ignorelabel==1){
  if(index($0,"(STOP)")>0) ignorelabel=0
}
else
if(ignorechar==1){
  if(index($0,")")==4) ignorechar=0
}
else
if(match($0,"CHARACTER O")>0){
#  octnum=$3
  latinnum=ctol($3)
  if(latinnum==-1){
    ignorechar=1
  }
  else
    print "(CHARACTER D",latinnum
  }
else {if(match($0,"LIG [O C]")>0){
        corsp=corspace($0)
        ligatyp=$2
 	liganum=$3
 	ligbtyp=$4
 	ligbnum=$5
 	ligbnum=substr(ligbnum,1,length(ligbnum)-1)
        if(ligatyp=="O"){
	  ligatyp="D"
	  liganum=ctol(liganum)
	}
	if(ligbtyp=="O"){
	  ligbtyp="D"
	  ligbnum=ctol(ligbnum)
	}
	if((lianum==-1)||(ligbnum==-1)){
	}
	else
          print corsp $1,ligatyp,liganum,ligbtyp,ligbnum ")"
     }
      else {if(match($0,"LABEL O")>0){
              corsp=corspace($0)
              labelnum=$3
	      labelnum=substr(labelnum,1,length(labelnum)-1)
	      labelnum=ctol(labelnum)
	      if(labelnum==-1){
	        ignorelabel=1}
	      else
                print corsp $1,"D",labelnum ")"
            } 
            else {if(match($0,"KRN O")>0){
	          corsp=corspace($0)
	          krnnum=ctol($3)
		  if(krnnum==-1){
		  }
		  else
                    print corsp $1,"D",krnnum,$4,$5
	           }
		  else print $0}
	   }
      }
}
